#ifndef _ARRAY_LIST_H_
#define _ARRAY_LIST_H_
#include <vector>
#include <iostream>
#include <stdlib.h>
#include <typeinfo>
#define SPLIT_THRES 1
using namespace std;

template <typename T>
class ArrayList
{
      protected:    
         int mSize;
         int mCapacity;
         vector<T>* mData;
	 bool splitted;
	 int  splitIndex; //[0, splitIndex) are larger
	                  //[splitIndex, mSize) are smaller
      public:
         ArrayList<T>();
         ArrayList<T>(vector<T>* data);
         ~ArrayList<T>();
         std::vector<T>* getData();
         std::vector<T>* getCopy();
         std::vector<T>* getSplitCopy();
         T getData(int i);
	 int getSize();
         void insert(T  data);
         void remove(T  data);
         void split_insert(T  data);
         void split_remove(T  data);
	 void split();
         int getSplitIndex() { return splitIndex; }
	 void permute();
};



template <typename T>
ArrayList<T>::ArrayList()
{
   mData=new vector<T>();
   mSize=0;
   mCapacity=0; 
   splitted=true;
   splitIndex=0;
}

template <typename T>
ArrayList<T>::ArrayList(vector<T>* data)
{
   mData=data;
   mSize=data->size();
   for(int i=0; i<mSize; i++)
   {
     (*mData)[i]->setIndex(i);
   }
   mCapacity=mSize;
   splitted=true;
   splitIndex=0;
}



template <typename T>
ArrayList<T>::~ArrayList()
{
   delete mData;
}


template <typename T> 
void 
ArrayList<T>::insert(T  data)
{
   splitted=false;
   if(mSize<mCapacity)
   {
      (*mData)[mSize]=data;
      data->setIndex(mSize);
      mSize++;
   }    
   else
   {
      mData->push_back(data);
      data->setIndex(mSize);
      mSize++;
      mCapacity++;
   }
}


template <typename T> 
void 
ArrayList<T>::split_insert(T  data)
{
   if(mSize>=mCapacity)
   {
      mData->push_back(data);
      mCapacity++;
   }
   if(data->getCounter()>SPLIT_THRES) 
   {
    (*mData)[mSize]=(*mData)[splitIndex];
    (*mData)[splitIndex]=data;
    
    (*mData)[splitIndex]->setIndex(splitIndex);
    (*mData)[mSize]->setIndex(mSize);
     splitIndex++;
     mSize++;
   }
   else
   {
       (*mData)[mSize]=data;
       (*mData)[mSize]->setIndex(mSize);
        mSize++;
   }
   if(splitIndex>mSize) cout<<"error at split insert"<<endl;
}

template <typename T> 
void 
ArrayList<T> ::remove(T data)
{
   mSize--;
    //mCapacity--;
   splitted=false; 
   int index=data->getIndex();
   //cout<<typeid(data).name()<<endl; 
   if((*mData)[index]!=data)
   {
        int* a=NULL;
	a[10]=10;
   }
   (*mData)[index]=(*mData)[mSize];
   (*mData)[index]->setIndex(index);  
   (*mData)[mSize]=NULL;
  // mData->pop_back();
}


template <typename T> 
void 
ArrayList<T>::split_remove(T data)
{
   mSize--;
   //mCapacity--;
    
   int index=data->getIndex();
   if(index>=splitIndex)
   {
     //if(data->getCounter()>SPLIT_THRES)
    if(index>mSize) 
       cout<<"split_thres error"<<data->getIndex()<<" "<<data->getCounter()<<" "<<mSize<<endl;
    (*mData)[index]=(*mData)[mSize];
    (*mData)[index]->setIndex(index);  
    (*mData)[mSize]=NULL;
 //   return; 
   }
   else
   {
     splitIndex--;
     //if(mSize!=splitIndex) cout<<index<<" "<<splitIndex<<" "<<mSize<<endl;
     if(mSize==0) return;
     
     (*mData)[index]=(*mData)[splitIndex];
     (*mData)[index]->setIndex(index);
     if(mSize!=splitIndex) 
     { 
       (*mData)[splitIndex]=(*mData)[mSize];
       (*mData)[splitIndex]->setIndex(splitIndex);
     }
     (*mData)[mSize]=NULL;
   }
   if(splitIndex>mSize) cout<<"error at split_remove"<<index<<" "<<splitIndex<<" "<<mSize<<endl;
}


template <typename T>
vector<T> *
ArrayList<T>::getData()
{
   return mData;
}

template <typename T>
vector<T> *
ArrayList<T>::getCopy()
{
   vector<T>* copy=new vector<T>(mSize);
   for(int i=0; i<mSize; i++)
   {
      (*copy)[i]=(*mData)[i];
   }
   return copy;
}

template <typename T>
vector<T> *
ArrayList<T>::getSplitCopy()
{
   vector<T>* copy=new vector<T>(splitIndex);
   for(int i=0; i<splitIndex; i++)
   {
      (*copy)[i]=(*mData)[i];
   }
   return copy;
}

template <typename T>
T 
ArrayList<T>::getData(int i)
{
   return (*mData)[i];
}



template <typename T>
int
ArrayList<T>::getSize()
{
   return mSize;
}

template <typename T>
void
ArrayList<T>::permute()
{
   if(mSize==0) return;
   for(int i=0; i<mSize; i++)
   {
      int which=random()%(mSize-i)+i;
      T d=(*mData)[i];
      (*mData)[i]=(*mData)[which];
      (*mData)[which]=d;
      (*mData)[i]->setIndex(i);
      (*mData)[which]->setIndex(which);
   }
   splitted=false;
}

template <typename T>
void
ArrayList<T>::split()
{
   if(mSize==0) return;
   if(splitted) return; 
   int lower=0;
   int upper=mSize-1;
   for(int i=lower; i<=upper; i++)
   {
      while(lower<=upper && (*mData)[lower]->getCounter()>SPLIT_THRES)
      {
        lower++;
      }

      while(upper>lower && (*mData)[upper]->getCounter()<=SPLIT_THRES)
      {
        upper--;
      }
      if(lower>=upper)
      {
         splitIndex=lower;
	 break;
      }
      T d=(*mData)[lower];
      (*mData)[lower]=(*mData)[upper];
      (*mData)[upper]=d;
      (*mData)[upper]->setIndex(upper);
      (*mData)[lower]->setIndex(lower);
   }
   splitted=true;
}

#endif

