#include "ClusterAccuracy.h"
ClusterAccuracy::ClusterAccuracy()
{
}

ClusterAccuracy::~ClusterAccuracy()
{
}



void
ClusterAccuracy::setFirstClustering(vector<vector<int>*>* clusters)
{
   mFirstClustering=clusters;
}


void
ClusterAccuracy::setSecondClustering(vector<vector<int>*>* clusters)
{
   mSecondClustering=clusters;
}

void
ClusterAccuracy::setSecondClustering(vector<Cluster*>* clusters)
{
   mSecondClustering=new vector<vector<int> *>();

   int s=clusters->size();

   for(int i=0; i<s; i++)
   {
     Cluster* c=(*clusters)[i];
     mSecondClustering->push_back(c->getVertexNumbers()); 
   }
}


double 
ClusterAccuracy::similarity(int i, int j)
{
   vector<int>* v1=(*mFirstClustering)[i];
   vector<int>* v2=(*mSecondClustering)[j];

   int s1=v1->size();
   int s2=v2->size();
   double rev=0;
   for(int i=0; i<s1; i++)
   {
      for(int j=0; j<s2; j++)
      {
          if((*v1)[i]==(*v2)[j]) rev+=1;
      }
   }
   return rev;
}

double
ClusterAccuracy::compare()
{
   double rev=0;
   int size1=mFirstClustering->size();
   int size2=mSecondClustering->size();

   bool* assigned=new bool[size1];
   int*   mapping=new int[size2];
   for(int i=0; i<size1; i++)
   {
      assigned[i]=false;
   }
   for(int j=0; j<size2; j++)
   {
      int which=0;
      double sim=-1;
      for(int i=0; i<size1; i++)
      {
         if(assigned[i]) continue;
         double s=similarity(i, j);      
         if(s>sim) 
	 {
	   sim=s;
	   which=i;
	 }
      }
      if(sim>0)
      { 
        assigned[which]=true;
        mapping[j]=which;
        rev+=sim;
      }
      else
      {
        mapping[j]=-1;
      }
   }
   return rev;
}
