#include "Graph.h"
#include <iostream>
#include <math.h>
#include <time.h>
using namespace std;
//======vertex=======
Vertex::Vertex(int num)
{
   mNode=num;
   mAdjacentList=new vector<Vertex* >();
}

void
Vertex::insertAdjacent(Vertex* n)
{
   mAdjacentList->push_back(n);
}

Vertex::~Vertex()
{
  delete mAdjacentList;
}

//----------Edge--------------


Edge::Edge(Vertex* s, Vertex* t)
{
   mSource=s;
   mTarget=t;
}
Edge::~Edge()
{

}




Graph::Graph(double alpha)
{
  mVertices=new vector<Vertex *>();
  mAlpha=alpha;
}


Graph::~Graph()
{
   int size=mVertices->size();
   for(int i=0; i<size; i++)
   {
     delete (*mVertices)[i];
   }
   delete mVertices;
}

void
Graph::randomPermuteVertex()
{
   srand(time(NULL));
   int size=mVertices->size();
   for(int i=0; i<size-1; i++)
   {
      Vertex* v=(*mVertices)[i];
      int s=(random()%(size-1));
      Vertex* t=(*mVertices)[s];
      (*mVertices)[i]=t;
      (*mVertices)[s]=v;
   }
   for(int i=0; i<size; i++)
   {
      (*mVertices)[i]->setNumber(i);
   }
}

void 
Graph::readGraph(char* aFileName)
{
   /*ifstream input(aFileName);
   if(!input)
   {
      cerr<<"Can not open file "<<aFileName<<endl;
      exit(0);
   }
   char line[1000];
   char* token; 
   while(!input.eof())
   {
      

   } */   
}

void
Graph::randomGraph(int numNode, int largestClique, double prob_remove, double prob_add)
{
  for(int i=0; i<numNode; i++)
  {
     mVertices->push_back(new Vertex(i));
  }//for
  int index=0;
  double credit=0;
  double correct_edge=0;
  double total_edge=0;
  while(index<numNode-1)
  {
     int size=random()%(largestClique-2)+2;
     if(index+size>numNode) size=numNode-index;
     credit-=(0.5*size*(size-1));
     for(int i=0; i<size; i++)
     {
       for(int j=i+1; j<size; j++)
       {
          double prob=random()*1.0/RAND_MAX;
          if(prob>prob_remove) 
          {
            (*mVertices)[i+index]->insertAdjacent((*mVertices)[j+index]);
            (*mVertices)[j+index]->insertAdjacent((*mVertices)[i+index]);
            credit+=(1+mAlpha);
            correct_edge+=1.0;
            total_edge+=1.0;
            //cout<<(i+index)<<" "<<(j+index)<<endl;
          }
       }
     } 
 
     index=index+size; 
  }//while
  randomPermuteVertex();
  for(int i=0; i<numNode; i++)
  {  
     for(int j=i+largestClique; j<numNode; j++)
     {
        double prob=random()*1.0/RAND_MAX;
        if(prob<prob_add)
        {
            (*mVertices)[i]->insertAdjacent((*mVertices)[j]);
            (*mVertices)[j]->insertAdjacent((*mVertices)[i]);      
            total_edge+=1;    
        } 

     }
  }    
  cout<<"Clique edge percent"<<(correct_edge/total_edge)<<endl;
  cout<<"Expected credit is:"<<credit<<endl;

}

void
Graph::generateGridGraph(int numNode, int largestClique, double prob_remove, double prob_add)
{
  int size=(int)sqrt(numNode);

  for(int i=0; i<numNode; i++)
  {
     mVertices->push_back(new Vertex(i));
  }//for
   
//  randomPermuteVertex();
  for(int i=0; i<size; i++)
  {
    for(int j=0; j<size; j++)
    {
       int this_index=i*size+j;
       if(j<size-1)
       {
         (*mVertices)[this_index]->insertAdjacent((*mVertices)[this_index+1]);
         (*mVertices)[this_index+1]->insertAdjacent((*mVertices)[this_index]);
       }
       int next_row_index=this_index+size;
       if(i<size-1)
       {
         (*mVertices)[this_index]->insertAdjacent((*mVertices)[next_row_index]);
         (*mVertices)[next_row_index]->insertAdjacent((*mVertices)[this_index]);
       }  
    }
  }
  randomPermuteVertex();
  cout<<"Expected credit is "<<((size/2)*(size/2)*10)<<endl;
}
