#ifndef _GRAPH_H_
#define _GRAPH_H_
#include <vector>
using namespace std;

class Vertex
{
   protected: 
    int mNode; 
    vector<Vertex *>* mAdjacentList;
    
   public: 
     Vertex(int num);
     ~Vertex();
    int getNumber() { return mNode;}
    void setNumber(int i) {  mNode=i;}
    void insertAdjacent(Vertex* n);
    vector<Vertex *>* getAdjacentList() { return mAdjacentList; }

};

class Edge
{
   protected:
     Vertex* mSource;
     Vertex* mTarget;
   public:
     Edge(Vertex* s, Vertex* t);
     ~Edge();
     Vertex* getSource() { return mSource; }
     Vertex* getTarget() { return mTarget; }

};

class Graph
{
    protected:
      vector<Vertex *>* mVertices;
      void  randomPermuteVertex();
      double mAlpha; 
    public:
      Graph(double alpha);
      ~Graph();
      void readGraph(char* aFileName);
      vector<Vertex *>* getVertices() { return mVertices;  } 
      void randomGraph(int numNode, int largestClique, double prob_remove, double prob_add);
      void generateGridGraph(int numNode, int largestClique, double prob_remove, double prob_add);
     
};

#endif 
