#ifndef _SIMPLE_HASH_H_
#define _SIMPLE_HASH_H_
#include <vector>
#include <iostream>
#include <stdlib.h>
using namespace std;

template <typename T1, typename T2>
class Pair
{
   public:
     T1 first;
     T2 second;
   public:
     Pair(T1 f, T2 s) { first =f; second=s;}
     ~Pair(){;}
};


template <typename T1, typename T2>
class SimpleHash
{
      protected: 
	 int mSize;   
         vector<vector<Pair<T1, T2>*>*>* mData;
      public:
         SimpleHash<T1, T2>(int size);
         ~SimpleHash<T1, T2>();
         void insert(T1 key, T2  data);
         void remove(T1 key);
	 Pair<T1, T2>* find(T1 key);
};


template <typename T1, typename T2>
SimpleHash<T1, T2>::SimpleHash(int size)
{
   if(size<=0) size=10;
   mData=new vector<vector<Pair<T1, T2> *>* >(size);
   mSize=size;
   for(int i=0; i<mSize; i++)
   {
     (*mData)[i]=new vector<Pair<T1, T2>* >(); 
   }
}

template <typename T1, typename T2>
SimpleHash<T1, T2>::~SimpleHash()
{
   for(int i=0; i<mSize; i++)
   {
     
      vector<Pair<T1, T2>* >* bin=(*mData)[i];
      int s2=bin->size();
      for(int j=0; j<s2; j++)
      {
         delete (*bin)[j];
      }
      delete bin;
   }	
   delete mData;
}


template <typename T1, typename T2>
void 
SimpleHash<T1, T2>::insert(T1 key, T2 data)
{
   unsigned long int address=(unsigned long int)key;
   int which_bin=address%mSize; 
   (*mData)[which_bin]->push_back(new Pair<T1, T2>(key, data));
}

template <typename T1, typename T2>
void 
SimpleHash<T1, T2>::remove(T1 key)
{
   unsigned long int address=(unsigned long int)key;
   int which_bin=address%mSize; 
   
   vector<Pair<T1, T2> *>* bin=(*mData)[which_bin];
   int size=bin->size();
   int i=0;
   for(i=0; i<size; i++)
   {
      if((*bin)[i]->first==key)
      {
         Pair<T1, T2>* temp=(*bin)[i];
	 (*bin)[i]= (*bin)[size-1];
	 delete temp;
	 bin->pop_back();
	 break;
      }
   }
}


template <typename T1, typename T2>
Pair<T1, T2>*
SimpleHash<T1, T2>::find(T1 key)
{
   if(mSize==0) return NULL;
   unsigned long int address=(unsigned long int)key;
   int which_bin=address%mSize; 
   
   vector<Pair<T1, T2>* >* bin=(*mData)[which_bin];
   int size=bin->size();
   int i=0;
   for(i=0; i<size; i++)
   {
      if((*bin)[i]->first==key)
      {
         return (*bin)[i];
      }
   }
   return NULL;
}

#endif

